// Kozak's Romaji Converter v1.1 by N'sLAB Copyright (C) 2006 by Nobumichi Kozawa
public class RomaConv
{
	private String [] a3r, a2r, a1r;
	private String [] a3h, a2h, a1h;
	private String [] a3k, a2k, a1k;
	private String [] a3n, a2n, a1n;
	private String [] i3r, i2r, i1r;
	private String [] i3h, i2h, i1h;
	private String [] i3k, i2k, i1k;
	private String [] i3n, i2n, i1n;
	private String [] u4r, u3r, u2r, u1r;
	private String [] u4h, u3h, u2h, u1h;
	private String [] u4k, u3k, u2k, u1k;
	private String [] u4n, u3n, u2n, u1n;
	private String [] e3r, e2r, e1r;
	private String [] e3h, e2h, e1h;
	private String [] e3k, e2k, e1k;
	private String [] e3n, e2n, e1n;
	private String [] o3r, o2r, o1r;
	private String [] o3h, o2h, o1h;
	private String [] o3k, o2k, o1k;
	private String [] o3n, o2n, o1n;

	
	public RomaConv()
	{
		a3r = new String[28];
		a3h = new String[28];
		a3k = new String[28];
		a3n = new String[28];
		a3r[0] = "kya"; a3h[0] = ""; a3k[0] = "L"; a3n[0] = "";
		a3r[1] = "kwa"; a3h[1] = ""; a3k[1] = "N@"; a3n[1] = "";
		a3r[2] = "sya"; a3h[2] = ""; a3k[2] = "V"; a3n[2] = "";
		a3r[3] = "sha"; a3h[3] = ""; a3k[3] = "V"; a3n[3] = "";
		a3r[4] = "tya"; a3h[4] = ""; a3k[4] = "`"; a3n[4] = "";
		a3r[5] = "cya"; a3h[5] = ""; a3k[5] = "`"; a3n[5] = "";
		a3r[6] = "cha"; a3h[6] = ""; a3k[6] = "`"; a3n[6] = "";
		a3r[7] = "tsa"; a3h[7] = ""; a3k[7] = "c@"; a3n[7] = "§";
		a3r[8] = "tha"; a3h[8] = "Ă"; a3k[8] = "e"; a3n[8] = "ì";
		a3r[9] = "nya"; a3h[9] = "ɂ"; a3k[9] = "j"; a3n[9] = "Ƭ";
		a3r[10] = "hya"; a3h[10] = "Ђ"; a3k[10] = "q"; a3n[10] = "ˬ";
		a3r[11] = "fya"; a3h[11] = "ӂ"; a3k[11] = "t"; a3n[11] = "̬";
		a3r[12] = "mya"; a3h[12] = "݂"; a3k[12] = "~"; a3n[12] = "Ь";
		a3r[13] = "lya"; a3h[13] = ""; a3k[13] = ""; a3n[13] = "";
		a3r[14] = "xya"; a3h[14] = ""; a3k[14] = ""; a3n[14] = "";
		a3r[15] = "rya"; a3h[15] = ""; a3k[15] = ""; a3n[15] = "ج";
		a3r[16] = "lwa"; a3h[16] = ""; a3k[16] = ""; a3n[16] = "";
		a3r[17] = "xwa"; a3h[17] = ""; a3k[17] = ""; a3n[17] = "";
		a3r[18] = "gya"; a3h[18] = ""; a3k[18] = "M"; a3n[18] = "ެ";
		a3r[19] = "gwa"; a3h[19] = ""; a3k[19] = "O@"; a3n[19] = "ާ";
		a3r[20] = "jya"; a3h[20] = ""; a3k[20] = "W"; a3n[20] = "ެ";
		a3r[21] = "zya"; a3h[21] = ""; a3k[21] = "W"; a3n[21] = "ެ";
		a3r[22] = "dya"; a3h[22] = ""; a3k[22] = "a"; a3n[22] = "ެ";
		a3r[23] = "dha"; a3h[23] = "ł"; a3k[23] = "f"; a3n[23] = "ެ";
		a3r[24] = "bya"; a3h[24] = "т"; a3k[24] = "r"; a3n[24] = "ެ";
		a3r[25] = "pya"; a3h[25] = "҂"; a3k[25] = "s"; a3n[25] = "߬";
		a3r[26] = "lka"; a3h[26] = ""; a3k[26] = ""; a3n[26] = "";
		a3r[27] = "xka"; a3h[27] = ""; a3k[27] = ""; a3n[27] = "";

		a2r = new String[19];
		a2h = new String[19];
		a2k = new String[19];
		a2n = new String[19];
		a2r[0] = "la"; a2h[0] = ""; a2k[0] = "@"; a2n[0] = "";
		a2r[1] = "xa"; a2h[1] = ""; a2k[1] = "@"; a2n[1] = "";
		a2r[2] = "ka"; a2h[2] = ""; a2k[2] = "J"; a2n[2] = "";
		a2r[3] = "sa"; a2h[3] = ""; a2k[3] = "T"; a2n[3] = "";
		a2r[4] = "ta"; a2h[4] = ""; a2k[4] = "^"; a2n[4] = "";
		a2r[5] = "na"; a2h[5] = ""; a2k[5] = "i"; a2n[5] = "";
		a2r[6] = "ha"; a2h[6] = ""; a2k[6] = "n"; a2n[6] = "";
		a2r[7] = "fa"; a2h[7] = "ӂ"; a2k[7] = "t@"; a2n[7] = "̧";
		a2r[8] = "ma"; a2h[8] = ""; a2k[8] = "}"; a2n[8] = "";
		a2r[9] = "ya"; a2h[9] = ""; a2k[9] = ""; a2n[9] = "";
		a2r[10] = "ra"; a2h[10] = ""; a2k[10] = ""; a2n[10] = "";
		a2r[11] = "wa"; a2h[11] = ""; a2k[11] = ""; a2n[11] = "";
		a2r[12] = "ga"; a2h[12] = ""; a2k[12] = "K"; a2n[12] = "";
		a2r[13] = "za"; a2h[13] = ""; a2k[13] = "U"; a2n[13] = "";
		a2r[14] = "ja"; a2h[14] = ""; a2k[14] = "W"; a2n[14] = "ެ";
		a2r[15] = "da"; a2h[15] = ""; a2k[15] = "_"; a2n[15] = "";
		a2r[16] = "ba"; a2h[16] = ""; a2k[16] = "o"; a2n[16] = "";
		a2r[17] = "pa"; a2h[17] = ""; a2k[17] = "p"; a2n[17] = "";
		a2r[18] = "va"; a2h[18] = "J"; a2k[18] = "@"; a2n[18] = "ާ";
		
		a1r = new String[1];
		a1h = new String[1];
		a1k = new String[1];
		a1n = new String[1];
		a1r[0] = "a"; a1h[0] = ""; a1k[0] = "A"; a1n[0] = "";

		i3r = new String[22];
		i3h = new String[22];
		i3k = new String[22];
		i3n = new String[22];
		i3r[0] = "kyi"; i3h[0] = ""; i3k[0] = "LB"; i3n[0] = "";
		i3r[1] = "syi"; i3h[1] = ""; i3k[1] = "VB"; i3n[1] = "";
		i3r[2] = "shi"; i3h[2] = ""; i3k[2] = "V"; i3n[2] = "";
		i3r[3] = "chi"; i3h[3] = ""; i3k[3] = "`"; i3n[3] = "";
		i3r[4] = "tyi"; i3h[4] = ""; i3k[4] = "`B"; i3n[4] = "";
		i3r[5] = "cyi"; i3h[5] = ""; i3k[5] = "`B"; i3n[5] = "";
		i3r[6] = "tsi"; i3h[6] = ""; i3k[6] = "cB"; i3n[6] = "¨";
		i3r[7] = "thi"; i3h[7] = "Ă"; i3k[7] = "eB"; i3n[7] = "è";
		i3r[8] = "nyi"; i3h[8] = "ɂ"; i3k[8] = "jB"; i3n[8] = "ƨ";
		i3r[9] = "hyi"; i3h[9] = "Ђ"; i3k[9] = "qB"; i3n[9] = "˨";
		i3r[10] = "fyi"; i3h[10] = "ӂ"; i3k[10] = "tB"; i3n[10] = "̨";
		i3r[11] = "myi"; i3h[11] = "݂"; i3k[11] = "~B"; i3n[11] = "Ш";
		i3r[12] = "lyi"; i3h[12] = ""; i3k[12] = "B"; i3n[12] = "";
		i3r[13] = "xyi"; i3h[13] = ""; i3k[13] = "B"; i3n[13] = "";
		i3r[14] = "ryi"; i3h[14] = "股"; i3k[14] = "B"; i3n[14] = "ب";
		i3r[15] = "gyi"; i3h[15] = ""; i3k[15] = "MB"; i3n[15] = "ި";
		i3r[16] = "jyi"; i3h[16] = ""; i3k[16] = "WB"; i3n[16] = "ި";
		i3r[17] = "zyi"; i3h[17] = ""; i3k[17] = "WB"; i3n[17] = "ި";
		i3r[18] = "dyi"; i3h[18] = ""; i3k[18] = "aB"; i3n[18] = "ި";
		i3r[19] = "dhi"; i3h[19] = "ł"; i3k[19] = "fB"; i3n[19] = "ި";
		i3r[20] = "byi"; i3h[20] = "т"; i3k[20] = "rB"; i3n[20] = "ި";
		i3r[21] = "pyi"; i3h[21] = "҂"; i3k[21] = "sB"; i3n[21] = "ߨ";

		i2r = new String[19];
		i2h = new String[19];
		i2k = new String[19];
		i2n = new String[19];
		i2r[0] = "li"; i2h[0] = ""; i2k[0] = "B"; i2n[0] = "";
		i2r[1] = "xi"; i2h[1] = ""; i2k[1] = "B"; i2n[1] = "";
		i2r[2] = "ki"; i2h[2] = ""; i2k[2] = "L"; i2n[2] = "";
		i2r[3] = "si"; i2h[3] = ""; i2k[3] = "V"; i2n[3] = "";
		i2r[4] = "ti"; i2h[4] = ""; i2k[4] = "`"; i2n[4] = "";
		i2r[5] = "ni"; i2h[5] = ""; i2k[5] = "j"; i2n[5] = "";
		i2r[6] = "hi"; i2h[6] = ""; i2k[6] = "q"; i2n[6] = "";
		i2r[7] = "fi"; i2h[7] = "ӂ"; i2k[7] = "tB"; i2n[7] = "̨";
		i2r[8] = "mi"; i2h[8] = ""; i2k[8] = "~"; i2n[8] = "";
		i2r[9] = "yi"; i2h[9] = ""; i2k[9] = "C"; i2n[9] = "";
		i2r[10] = "ri"; i2h[10] = ""; i2k[10] = ""; i2n[10] = "";
		i2r[11] = "wi"; i2h[11] = ""; i2k[11] = "EB"; i2n[11] = "";
		i2r[12] = "gi"; i2h[12] = ""; i2k[12] = "M"; i2n[12] = "";
		i2r[13] = "zi"; i2h[13] = ""; i2k[13] = "W"; i2n[13] = "";
		i2r[14] = "ji"; i2h[14] = ""; i2k[14] = "W"; i2n[14] = "";
		i2r[15] = "di"; i2h[15] = ""; i2k[15] = "a"; i2n[15] = "";
		i2r[16] = "bi"; i2h[16] = ""; i2k[16] = "r"; i2n[16] = "";
		i2r[17] = "pi"; i2h[17] = ""; i2k[17] = "s"; i2n[17] = "";
		i2r[18] = "vi"; i2h[18] = "J"; i2k[18] = "B"; i2n[18] = "ި";

		i1r = new String[1];
		i1h = new String[1];
		i1k = new String[1];
		i1n = new String[1];
		i1r[0] = "i"; i1h[0] = ""; i1k[0] = "C"; i1n[0] = "";

		u4r = new String[2];
		u4h = new String[2];
		u4k = new String[2];
		u4n = new String[2];
		u4r[0] = "ltsu"; u4h[0] = ""; u4k[0] = "b"; u4n[0] = "";
		u4r[1] = "xtsu"; u4h[1] = ""; u4k[1] = "b"; u4n[1] = "";

		u3r = new String[26];
		u3h = new String[26];
		u3k = new String[26];
		u3n = new String[26];
		u3r[0] = "kyu"; u3h[0] = ""; u3k[0] = "L"; u3n[0] = "";
		u3r[1] = "syu"; u3h[1] = ""; u3k[1] = "V"; u3n[1] = "";
		u3r[2] = "shu"; u3h[2] = ""; u3k[2] = "V"; u3n[2] = "";
		u3r[3] = "tsu"; u3h[3] = ""; u3k[3] = "c"; u3n[3] = "";
		u3r[4] = "ltu"; u3h[4] = ""; u3k[4] = "b"; u3n[4] = "";
		u3r[5] = "xtu"; u3h[5] = ""; u3k[5] = "b"; u3n[5] = "";
		u3r[6] = "tyu"; u3h[6] = ""; u3k[6] = "`"; u3n[6] = "";
		u3r[7] = "cyu"; u3h[7] = ""; u3k[7] = "`"; u3n[7] = "";
		u3r[8] = "chu"; u3h[8] = ""; u3k[8] = "`"; u3n[8] = "";
		u3r[9] = "thu"; u3h[9] = "Ă"; u3k[9] = "e"; u3n[9] = "í";
		u3r[10] = "twu"; u3h[10] = "Ƃ"; u3k[10] = "gD"; u3n[10] = "ĩ";
		u3r[11] = "nyu"; u3h[11] = "ɂ"; u3k[11] = "j"; u3n[11] = "ƭ";
		u3r[12] = "hyu"; u3h[12] = "Ђ"; u3k[12] = "q"; u3n[12] = "˭";
		u3r[13] = "fyu"; u3h[13] = "ӂ"; u3k[13] = "t"; u3n[13] = "̭";
		u3r[14] = "myu"; u3h[14] = "݂"; u3k[14] = "~"; u3n[14] = "Э";
		u3r[15] = "lyu"; u3h[15] = ""; u3k[15] = ""; u3n[15] = "";
		u3r[16] = "xyu"; u3h[16] = ""; u3k[16] = ""; u3n[16] = "";
		u3r[17] = "ryu"; u3h[17] = ""; u3k[17] = ""; u3n[17] = "ح";
		u3r[18] = "gyu"; u3h[18] = ""; u3k[18] = "M"; u3n[18] = "ޭ";
		u3r[19] = "jyu"; u3h[19] = ""; u3k[19] = "W"; u3n[19] = "ޭ";
		u3r[20] = "zyu"; u3h[20] = ""; u3k[20] = "W"; u3n[20] = "ޭ";
		u3r[21] = "dyu"; u3h[21] = ""; u3k[21] = "a"; u3n[21] = "ޭ";
		u3r[22] = "dhu"; u3h[22] = "ł"; u3k[22] = "f"; u3n[22] = "ޭ";
		u3r[23] = "dwu"; u3h[23] = "ǂ"; u3k[23] = "hD"; u3n[23] = "ީ";
		u3r[24] = "byu"; u3h[24] = "т"; u3k[24] = "r"; u3n[24] = "ޭ";
		u3r[25] = "pyu"; u3h[25] = "҂"; u3k[25] = "s"; u3n[25] = "߭";

		u2r = new String[19];
		u2h = new String[19];
		u2k = new String[19];
		u2n = new String[19];
		u2r[0] = "lu"; u2h[0] = ""; u2k[0] = "D"; u2n[0] = "";
		u2r[1] = "xu"; u2h[1] = ""; u2k[1] = "D"; u2n[1] = "";
		u2r[2] = "ku"; u2h[2] = ""; u2k[2] = "N"; u2n[2] = "";
		u2r[3] = "su"; u2h[3] = ""; u2k[3] = "X"; u2n[3] = "";
		u2r[4] = "tu"; u2h[4] = ""; u2k[4] = "c"; u2n[4] = "";
		u2r[5] = "nu"; u2h[5] = ""; u2k[5] = "k"; u2n[5] = "";
		u2r[6] = "hu"; u2h[6] = ""; u2k[6] = "t"; u2n[6] = "";
		u2r[7] = "fu"; u2h[7] = ""; u2k[7] = "t"; u2n[7] = "";
		u2r[8] = "mu"; u2h[8] = ""; u2k[8] = ""; u2n[8] = "";
		u2r[9] = "yu"; u2h[9] = ""; u2k[9] = ""; u2n[9] = "";
		u2r[10] = "ru"; u2h[10] = ""; u2k[10] = ""; u2n[10] = "";
		u2r[11] = "wu"; u2h[11] = ""; u2k[11] = "E"; u2n[11] = "";
		u2r[12] = "gu"; u2h[12] = ""; u2k[12] = "O"; u2n[12] = "";
		u2r[13] = "zu"; u2h[13] = ""; u2k[13] = "Y"; u2n[13] = "";
		u2r[14] = "ju"; u2h[14] = ""; u2k[14] = "W"; u2n[14] = "ޭ";
		u2r[15] = "du"; u2h[15] = ""; u2k[15] = "d"; u2n[15] = "";
		u2r[16] = "bu"; u2h[16] = ""; u2k[16] = "u"; u2n[16] = "";
		u2r[17] = "pu"; u2h[17] = ""; u2k[17] = "v"; u2n[17] = "";
		u2r[18] = "vu"; u2h[18] = "J"; u2k[18] = ""; u2n[18] = "";

		u1r = new String[1];
		u1h = new String[1];
		u1k = new String[1];
		u1n = new String[1];
		u1r[0] = "u"; u1h[0] = ""; u1k[0] = "E"; u1n[0] = "";

		e3r = new String[24];
		e3h = new String[24];
		e3k = new String[24];
		e3n = new String[24];
		e3r[0] = "kye"; e3h[0] = ""; e3k[0] = "LF"; e3n[0] = "";
		e3r[1] = "sye"; e3h[1] = ""; e3k[1] = "VF"; e3n[1] = "";
		e3r[2] = "she"; e3h[2] = ""; e3k[2] = "VF"; e3n[2] = "";
		e3r[3] = "tye"; e3h[3] = ""; e3k[3] = "`F"; e3n[3] = "";
		e3r[4] = "cye"; e3h[4] = ""; e3k[4] = "`F"; e3n[4] = "";
		e3r[5] = "che"; e3h[5] = ""; e3k[5] = "`F"; e3n[5] = "";
		e3r[6] = "tse"; e3h[6] = ""; e3k[6] = "cF"; e3n[6] = "ª";
		e3r[7] = "the"; e3h[7] = "Ă"; e3k[7] = "eF"; e3n[7] = "ê";
		e3r[8] = "nye"; e3h[8] = "ɂ"; e3k[8] = "jF"; e3n[8] = "ƪ";
		e3r[9] = "hye"; e3h[9] = "Ђ"; e3k[9] = "qF"; e3n[9] = "˪";
		e3r[10] = "fye"; e3h[10] = "ӂ"; e3k[10] = "tF"; e3n[10] = "̪";
		e3r[11] = "mye"; e3h[11] = "݂"; e3k[11] = "~F"; e3n[11] = "Ъ";
		e3r[12] = "lye"; e3h[12] = ""; e3k[12] = "F"; e3n[12] = "";
		e3r[13] = "xye"; e3h[13] = ""; e3k[13] = "F"; e3n[13] = "";
		e3r[14] = "rye"; e3h[14] = "肥"; e3k[14] = "F"; e3n[14] = "ت";
		e3r[15] = "gye"; e3h[15] = ""; e3k[15] = "MF"; e3n[15] = "ު";
		e3r[16] = "jye"; e3h[16] = ""; e3k[16] = "WF"; e3n[16] = "ު";
		e3r[17] = "zye"; e3h[17] = ""; e3k[17] = "WF"; e3n[17] = "ު";
		e3r[18] = "dye"; e3h[18] = ""; e3k[18] = "aF"; e3n[18] = "ު";
		e3r[19] = "dhe"; e3h[19] = "ł"; e3k[19] = "fF"; e3n[19] = "ު";
		e3r[20] = "bye"; e3h[20] = "т"; e3k[20] = "rF"; e3n[20] = "ު";
		e3r[21] = "pye"; e3h[21] = "҂"; e3k[21] = "sF"; e3n[21] = "ߪ";
		e3r[22] = "lke"; e3h[22] = ""; e3k[22] = ""; e3n[22] = "";
		e3r[23] = "xke"; e3h[23] = ""; e3k[23] = ""; e3n[23] = "";

		e2r = new String[19];
		e2h = new String[19];
		e2k = new String[19];
		e2n = new String[19];
		e2r[0] = "le"; e2h[0] = ""; e2k[0] = "F"; e2n[0] = "";
		e2r[1] = "xe"; e2h[1] = ""; e2k[1] = "F"; e2n[1] = "";
		e2r[2] = "ke"; e2h[2] = ""; e2k[2] = "P"; e2n[2] = "";
		e2r[3] = "se"; e2h[3] = ""; e2k[3] = "Z"; e2n[3] = "";
		e2r[4] = "te"; e2h[4] = ""; e2k[4] = "e"; e2n[4] = "";
		e2r[5] = "ne"; e2h[5] = ""; e2k[5] = "l"; e2n[5] = "";
		e2r[6] = "he"; e2h[6] = ""; e2k[6] = "w"; e2n[6] = "";
		e2r[7] = "fe"; e2h[7] = "ӂ"; e2k[7] = "tF"; e2n[7] = "̪";
		e2r[8] = "me"; e2h[8] = ""; e2k[8] = ""; e2n[8] = "";
		e2r[9] = "ye"; e2h[9] = ""; e2k[9] = "CF"; e2n[9] = "";
		e2r[10] = "re"; e2h[10] = ""; e2k[10] = ""; e2n[10] = "";
		e2r[11] = "we"; e2h[11] = ""; e2k[11] = "EF"; e2n[11] = "";
		e2r[12] = "ge"; e2h[12] = ""; e2k[12] = "Q"; e2n[12] = "";
		e2r[13] = "ze"; e2h[13] = ""; e2k[13] = "["; e2n[13] = "";
		e2r[14] = "je"; e2h[14] = ""; e2k[14] = "WF"; e2n[14] = "ު";
		e2r[15] = "de"; e2h[15] = ""; e2k[15] = "f"; e2n[15] = "";
		e2r[16] = "be"; e2h[16] = ""; e2k[16] = "x"; e2n[16] = "";
		e2r[17] = "pe"; e2h[17] = ""; e2k[17] = "y"; e2n[17] = "";
		e2r[18] = "ve"; e2h[18] = "J"; e2k[18] = "F"; e2n[18] = "ު";

		e1r = new String[1];
		e1h = new String[1];
		e1k = new String[1];
		e1n = new String[1];
		e1r[0] = "e"; e1h[0] = ""; e1k[0] = "G"; e1n[0] = "";

		o3r = new String[22];
		o3h = new String[22];
		o3k = new String[22];
		o3n = new String[22];
		o3r[0] = "kyo"; o3h[0] = ""; o3k[0] = "L"; o3n[0] = "";
		o3r[1] = "syo"; o3h[1] = ""; o3k[1] = "V"; o3n[1] = "";
		o3r[2] = "sho"; o3h[2] = ""; o3k[2] = "V"; o3n[2] = "";
		o3r[3] = "tyo"; o3h[3] = ""; o3k[3] = "`"; o3n[3] = "";
		o3r[4] = "cyo"; o3h[4] = ""; o3k[4] = "`"; o3n[4] = "";
		o3r[5] = "cho"; o3h[5] = ""; o3k[5] = "`"; o3n[5] = "";
		o3r[6] = "tso"; o3h[6] = ""; o3k[6] = "cH"; o3n[6] = "«";
		o3r[7] = "tho"; o3h[7] = "Ă"; o3k[7] = "e"; o3n[7] = "î";
		o3r[8] = "nyo"; o3h[8] = "ɂ"; o3k[8] = "j"; o3n[8] = "Ʈ";
		o3r[9] = "hyo"; o3h[9] = "Ђ"; o3k[9] = "q"; o3n[9] = "ˮ";
		o3r[10] = "fyo"; o3h[10] = "ӂ"; o3k[10] = "t"; o3n[10] = "̮";
		o3r[11] = "myo"; o3h[11] = "݂"; o3k[11] = "~"; o3n[11] = "Ю";
		o3r[12] = "lyo"; o3h[12] = ""; o3k[12] = ""; o3n[12] = "";
		o3r[13] = "xyo"; o3h[13] = ""; o3k[13] = ""; o3n[13] = "";
		o3r[14] = "ryo"; o3h[14] = ""; o3k[14] = ""; o3n[14] = "خ";
		o3r[15] = "gyo"; o3h[15] = ""; o3k[15] = "M"; o3n[15] = "ޮ";
		o3r[16] = "jyo"; o3h[16] = ""; o3k[16] = "W"; o3n[16] = "ޮ";
		o3r[17] = "zyo"; o3h[17] = ""; o3k[17] = "W"; o3n[17] = "ޮ";
		o3r[18] = "dyo"; o3h[18] = ""; o3k[18] = "a"; o3n[18] = "ޮ";
		o3r[19] = "dho"; o3h[19] = "ł"; o3k[19] = "f"; o3n[19] = "ޮ";
		o3r[20] = "byo"; o3h[20] = "т"; o3k[20] = "r"; o3n[20] = "ޮ";
		o3r[21] = "pyo"; o3h[21] = "҂"; o3k[21] = "s"; o3n[21] = "߮";

		o2r = new String[19];
		o2h = new String[19];
		o2k = new String[19];
		o2n = new String[19];
		o2r[0] = "lo"; o2h[0] = ""; o2k[0] = "H"; o2n[0] = "";
		o2r[1] = "xo"; o2h[1] = ""; o2k[1] = "H"; o2n[1] = "";
		o2r[2] = "ko"; o2h[2] = ""; o2k[2] = "R"; o2n[2] = "";
		o2r[3] = "so"; o2h[3] = ""; o2k[3] = "\"; o2n[3] = "";
		o2r[4] = "to"; o2h[4] = ""; o2k[4] = "g"; o2n[4] = "";
		o2r[5] = "no"; o2h[5] = ""; o2k[5] = "m"; o2n[5] = "";
		o2r[6] = "ho"; o2h[6] = ""; o2k[6] = "z"; o2n[6] = "";
		o2r[7] = "fo"; o2h[7] = "ӂ"; o2k[7] = "tH"; o2n[7] = "̫";
		o2r[8] = "mo"; o2h[8] = ""; o2k[8] = ""; o2n[8] = "";
		o2r[9] = "yo"; o2h[9] = ""; o2k[9] = ""; o2n[9] = "";
		o2r[10] = "ro"; o2h[10] = ""; o2k[10] = ""; o2n[10] = "";
		o2r[11] = "wo"; o2h[11] = ""; o2k[11] = ""; o2n[11] = "";
		o2r[12] = "go"; o2h[12] = ""; o2k[12] = "S"; o2n[12] = "";
		o2r[13] = "zo"; o2h[13] = ""; o2k[13] = "]"; o2n[13] = "";
		o2r[14] = "jo"; o2h[14] = ""; o2k[14] = "W"; o2n[14] = "ޮ";
		o2r[15] = "do"; o2h[15] = ""; o2k[15] = "h"; o2n[15] = "";
		o2r[16] = "bo"; o2h[16] = ""; o2k[16] = "{"; o2n[16] = "";
		o2r[17] = "po"; o2h[17] = ""; o2k[17] = "|"; o2n[17] = "";
		o2r[18] = "vo"; o2h[18] = "J"; o2k[18] = "H"; o2n[18] = "ޫ";

		o1r = new String[1];
		o1h = new String[1];
		o1k = new String[1];
		o1n = new String[1];
		o1r[0] = "o"; o1h[0] = ""; o1k[0] = "I"; o1n[0] = "";
	}
	
	public String getMoji(int mode, String roma)
	{
		int i, len = roma.length();
		String roma2 = roma.toLowerCase();
		String result;
		if (0 == roma2.substring(len - 1).compareTo("a")) {
			if (len >= 3) {
				for (i = 0; i < a3r.length; i++) {
					if (0 == a3r[i].compareTo(roma2.substring(len - 3))) {
						switch (mode) {
							case 0 : result = a3h[i]; break;
							case 1 : result = a3k[i]; break;
							case 2 : result = a3n[i]; break;
							default : result = "";
						}
						if (0 == result.compareTo("")) return roma;
						else if (len > 3) return roma.substring(0, len - 3) + result;
						else return result;
					}
				}
			}
			if (len >= 2) {
				for (i = 0; i < a2r.length; i++) {
					if (0 == a2r[i].compareTo(roma2.substring(len - 2))) {
						switch (mode) {
							case 0 : result = a2h[i]; break;
							case 1 : result = a2k[i]; break;
							case 2 : result = a2n[i]; break;
							default : result = "";
						}
						if (0 == result.compareTo("")) return roma;
						else if (len > 2) return roma.substring(0, len - 2) + result;
						else return result;
					}
				}
			}
			if (len >= 1) {
				if (0 == a1r[0].compareTo(roma2.substring(len - 1))) {
					switch (mode) {
						case 0 : result = a1h[0]; break;
						case 1 : result = a1k[0]; break;
						case 2 : result = a1n[0]; break;
						default : result = "";
					}
					if (0 == result.compareTo("")) return roma;
					else if (len > 1) return roma.substring(0, len - 1) + result;
					else return result;
				}
				return roma;
			}
		}
		if (0 == roma2.substring(len - 1).compareTo("i")) {
			if (len >= 3) {
				for (i = 0; i < i3r.length; i++) {
					if (0 == i3r[i].compareTo(roma2.substring(len - 3))) {
						switch (mode) {
							case 0 : result = i3h[i]; break;
							case 1 : result = i3k[i]; break;
							case 2 : result = i3n[i]; break;
							default : result = "";
						}
						if (0 == result.compareTo("")) return roma;
						else if (len > 3) return roma.substring(0, len - 3) + result;
						else return result;
					}
				}
			}
			if (len >= 2) {
				for (i = 0; i < i2r.length; i++) {
					if (0 == i2r[i].compareTo(roma2.substring(len - 2))) {
						switch (mode) {
							case 0 : result = i2h[i]; break;
							case 1 : result = i2k[i]; break;
							case 2 : result = i2n[i]; break;
							default : result = "";
						}
						if (0 == result.compareTo("")) return roma;
						else if (len > 2) return roma.substring(0, len - 2) + result;
						else return result;
					}
				}
			}
			if (len >= 1) {
				if (0 == i1r[0].compareTo(roma2.substring(len - 1))) {
					switch (mode) {
						case 0 : result = i1h[0]; break;
						case 1 : result = i1k[0]; break;
						case 2 : result = i1n[0]; break;
						default : result = "";
					}
					if (0 == result.compareTo("")) return roma;
					else if (len > 1) return roma.substring(0, len - 1) + result;
					else return result;
				}
				return roma;
			}
		}
		if (0 == roma2.substring(len - 1).compareTo("u")) {
			if (len >= 4) {
				for (i = 0; i < u4r.length; i++) {
					if (0 == u4r[i].compareTo(roma2.substring(len - 4))) {
						switch (mode) {
							case 0 : result = u4h[i]; break;
							case 1 : result = u4k[i]; break;
							case 2 : result = u4n[i]; break;
							default : result = "";
						}
						if (0 == result.compareTo("")) return roma;
						else if (len > 4) return roma.substring(0, len - 4) + result;
						else return result;
					}
				}
			}
			if (len >= 3) {
				for (i = 0; i < u3r.length; i++) {
					if (0 == u3r[i].compareTo(roma2.substring(len - 3))) {
						switch (mode) {
							case 0 : result = u3h[i]; break;
							case 1 : result = u3k[i]; break;
							case 2 : result = u3n[i]; break;
							default : result = "";
						}
						if (0 == result.compareTo("")) return roma;
						else if (len > 3) return roma.substring(0, len - 3) + result;
						else return result;
					}
				}
			}
			if (len >= 2) {
				for (i = 0; i < u2r.length; i++) {
					if (0 == u2r[i].compareTo(roma2.substring(len - 2))) {
						switch (mode) {
							case 0 : result = u2h[i]; break;
							case 1 : result = u2k[i]; break;
							case 2 : result = u2n[i]; break;
							default : result = "";
						}
						if (0 == result.compareTo("")) return roma;
						else if (len > 2) return roma.substring(0, len - 2) + result;
						else return result;
					}
				}
			}
			if (len >= 1) {
				if (0 == u1r[0].compareTo(roma2.substring(len - 1))) {
					switch (mode) {
						case 0 : result = u1h[0]; break;
						case 1 : result = u1k[0]; break;
						case 2 : result = u1n[0]; break;
						default : result = "";
					}
					if (0 == result.compareTo("")) return roma;
					else if (len > 1) return roma.substring(0, len - 1) + result;
					else return result;
				}
				return roma;
			}
		}
		if (0 == roma2.substring(len - 1).compareTo("e")) {
			if (len >= 3) {
				for (i = 0; i < e3r.length; i++) {
					if (0 == e3r[i].compareTo(roma2.substring(len - 3))) {
						switch (mode) {
							case 0 : result = e3h[i]; break;
							case 1 : result = e3k[i]; break;
							case 2 : result = e3n[i]; break;
							default : result = "";
						}
						if (0 == result.compareTo("")) return roma;
						else if (len > 3) return roma.substring(0, len - 3) + result;
						else return result;
					}
				}
			}
			if (len >= 2) {
				for (i = 0; i < e2r.length; i++) {
					if (0 == e2r[i].compareTo(roma2.substring(len - 2))) {
						switch (mode) {
							case 0 : result = e2h[i]; break;
							case 1 : result = e2k[i]; break;
							case 2 : result = e2n[i]; break;
							default : result = "";
						}
						if (0 == result.compareTo("")) return roma;
						else if (len > 2) return roma.substring(0, len - 2) + result;
						else return result;
					}
				}
			}
			if (len >= 1) {
				if (0 == e1r[0].compareTo(roma2.substring(len - 1))) {
					switch (mode) {
						case 0 : result = e1h[0]; break;
						case 1 : result = e1k[0]; break;
						case 2 : result = e1n[0]; break;
						default : result = "";
					}
					if (0 == result.compareTo("")) return roma;
					else if (len > 1) return roma.substring(0, len - 1) + result;
					else return result;
				}
				return roma;
			}
		}
		if (0 == roma2.substring(len - 1).compareTo("o")) {
			if (len >= 3) {
				for (i = 0; i < o3r.length; i++) {
					if (0 == o3r[i].compareTo(roma2.substring(len - 3))) {
						switch (mode) {
							case 0 : result = o3h[i]; break;
							case 1 : result = o3k[i]; break;
							case 2 : result = o3n[i]; break;
							default : result = "";
						}
						if (0 == result.compareTo("")) return roma;
						else if (len > 3) return roma.substring(0, len - 3) + result;
						else return result;
					}
				}
			}
			if (len >= 2) {
				for (i = 0; i < o2r.length; i++) {
					if (0 == o2r[i].compareTo(roma2.substring(len - 2))) {
						switch (mode) {
							case 0 : result = o2h[i]; break;
							case 1 : result = o2k[i]; break;
							case 2 : result = o2n[i]; break;
							default : result = "";
						}
						if (0 == result.compareTo("")) return roma;
						else if (len > 2) return roma.substring(0, len - 2) + result;
						else return result;
					}
				}
			}
			if (len >= 1) {
				if (0 == o1r[0].compareTo(roma2.substring(len - 1))) {
					switch (mode) {
						case 0 : result = o1h[0]; break;
						case 1 : result = o1k[0]; break;
						case 2 : result = o1n[0]; break;
						default : result = "";
					}
					if (0 == result.compareTo("")) return roma;
					else if (len > 1) return roma.substring(0, len - 1) + result;
					else return result;
				}
				return roma;
			}
		}
		return roma;
	}
}
